# Before You Start

Please read this [DOCS](https://tensorlayerx.readthedocs.io/en/latest/user/get_start_model.html) before you start.

## Define a model
TensorLayerX provides Sequential and Subclass define a model. Sequential model allows you to build model in a fluent way while Subclass allows you to fully control the forward process.
- [Sequential Model](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/mnist_SequentialLayer.py)
- [Layer List](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/tutorial_LayerList.py)
- [Nested Usage of Layer](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/nested_usage_of_layer.py) 
- [Automatic Inference Input Shape](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/automatic_inference_input_shape.py)

## Data processing
- [MNIST Dataflow](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/mnist_dataflow.py)

## Model training
- [MNIST MLP](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/mnist_mlp.py)
- [MNIST GAN](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/mnist_gan.py)
- [CIFAR10 CNN](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/cifar10_cnn.py)
- [IMDB LSTM](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/imdb_LSTM_simple.py)

## TensorLayerX and other frameworks
- [CIFAR10 CNN Mixed MindSpore](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/cifar10_cnn_mixed_mindspore.py)
- [CIFAR10 CNN Mixed Paddle](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/cifar10_cnn_mixed_paddle.py)
- [CIFAR10 CNN Mixed TensorFlow](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/cifar10_cnn_mixed_tensorflow.py)
- [MNIST MLP Mixed MindSpore](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/mnist_mlp_mixed_mindspore.py)
- [MNIST MLP Mixed Paddle](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/mnist_mlp_mixed_paddle.py)
- [MNIST MLP Mixed TensorFlow](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/mnist_mlp_mixed_tensorflow.py)
- [MNIST MLP Mixed PyTorch](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/mnist_mlp_mixed_torch.py)

## Others
- [Interoperability of Different Back-end Models](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/tutorial_tensorlayer_model_load.py)
- [TensorFlow Model Save to pb](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/tensorflow_model_save_to_pb.py)
- [Gradient Clip](https://github.com/tensorlayer/TensorLayerX/blob/main/examples/basic_tutorials/gradient_clip_mixed_tensorflow.py)